import math
import sys

# Integers are unbounded in Python 3.x

my_int = int()
print('my_int', my_int)  # '0'
print('Size of \'int\'',
      sys.getsizeof(int()))  # Size (in bytes) of an *instance* of the 'int' class, namely size of '0'...
# Disappeared from Python 3.x:
# print('long', sys.getsizeof(long()))  # Size of an *instance* of the 'long' class

one_bit_set = [False, False, False, False, False, False, False, True]  # 8 bits...
one = int()
for value in one_bit_set:
    one = one << 1
    one = one | 1 if value else one
print(bin(one))  # '0b1'

two_bit_set = [False, False, False, False, False, False, True, False]
two = int()
for value in two_bit_set:
    two = two << 1
    two = two | 1 if value else two
print(bin(two))  # '0b10'

three = int('00000011', 2)
print(three)

minus_nine = ~(9 - 1)
print(minus_nine, bin(minus_nine))

minus_ten = ~(10 - 1)
print(minus_ten, bin(minus_ten))

print(type(math.pi))  # '<class 'float'>'
# https://docs.python.org/3/library/stdtypes.html#float.hex ->
print(float.hex(math.pi))  # [sign] ['0x'] integer ['.' fraction] ['p' exponent] -> '0x1.921fb54442d18p+1'
print(float.fromhex('0x1.921fb54442d18p+1'))

# https://docs.python.org/3/library/sys.html#sys.float_info
print('Max float: ', sys.float_info.max)
print('Epsilon such that there is *no* \'x\' such that \'1 < x < 1 + sys.float_info.epsilon\': ',
      sys.float_info.epsilon)
# Floating point numbers are not primitive:
my_float = float()
my_other_float = float()
my_yet_another_float = my_float

print(my_float == my_other_float)  # 'True' is displayed since both are qual to '0'
assert (not my_float is my_other_float)  # 'is' and 'id()' are *totally* equivalent
assert (my_float is my_yet_another_float)
assert (not id(my_float) == id(my_other_float))
assert (id(my_float) == id(my_yet_another_float))
